Wt: Wt::Chart::WCartesian3DChart Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Classes | Public Member Functions | Protected Member Functions | List of all members
Wt::Chart::WCartesian3DChart Class Reference
Charts (Wt::Chart)

A 3D Cartesian chart. More...

`#include <WCartesian3DChart.h>`

Inheritance diagram for Wt::Chart::WCartesian3DChart:
[legend]

## Classes
class | IntersectionPlane
| An invisible intersection plane. More...

## Public Member Functions
| WCartesian3DChart ()
| Constructor.
| WCartesian3DChart (ChartType type)
| Constructor.
| ~WCartesian3DChart ()
| Destructor.
void | addDataSeries (std::unique_ptr< WAbstractDataSeries3D > dataseries)
| Add a dataseries to the chart.
std::unique_ptr< WAbstractDataSeries3D > | removeDataSeries (WAbstractDataSeries3D *dataseries)
| Removes a dataseries from a chart.
std::vector< WAbstractDataSeries3D * > | dataSeries () const
| Returns all dataseries that were added to this chart.
WAxis & | axis (Axis axis)
| Returns the specified axis belonging to the chart.
const WAxis & | axis (Axis axis) const
| Returns the specified axis belonging to the chart.
void | setAxis (std::unique_ptr< WAxis > waxis, Axis axis)
| Sets an axis.
void | setGridEnabled (Plane plane, Axis axis, bool enabled=true)
| Enable/disable gridlines.
bool | isGridEnabled (Plane plane, Axis axis)
| Returns whether the gridlines are enabled.
void | setIntersectionLinesEnabled (bool enabled=true)
| Set whether intersection lines are shown between surface charts.
bool | isIntersectionLinesEnabled () const
| Returns whether intersection lines are shown between surface charts.
void | setIntersectionLinesColor (WColor color)
| Sets the color of the intersection lines between surface charts.
const WColor & | intersectionLinesColor () const
| Gets the color of the intersection lines between surface charts.
void | setIntersectionPlanes (const std::vector< IntersectionPlane > &intersectionPlanes)
| Set the invisible planes with which intersections are drawn.
const std::vector< IntersectionPlane > & | intersectionPlanes () const
| Get the invisible planes with which intersections are drawn.
void | setGridLinesPen (const WPen &pen)
| Sets the pen used for drawing the gridlines.
const WPen & | gridLinesPen () const
| Returns the pen used for drawing the gridlines.
void | setCubeLinesPen (const WPen &pen)
| Sets the pen used to draw the edges of the plotcube.
const WPen & | cubeLinesPen () const
| Returns a reference to the pen used for drawing the edges of the plotcube.
void | setType (ChartType type)
| Sets the type of this chart.
ChartType | type () const
| Returns the type of this chart.
void | setPalette (const std::shared_ptr< WChartPalette > &palette)
| Sets the palette for this chart.
std::shared_ptr< WChartPalette > | palette () const
| Returns the palette used for this chart.
void | setBackground (const WColor &background)
| Sets the background color for this chart.
const WColor & | background () const
| Returns the background color used for this chart.
void | setTitle (const WString &title)
| Sets the title that is put on the chart.
const WString & | title () const
| Returns the title that is put at the top of this chart.
void | setTitleFont (const WFont &titleFont)
| Sets the font that is used to draw the title.
const WFont & | titleFont () const
| Returns the font used to draw the title.
void | setLegendEnabled (bool enabled)
| Enables the legend.
bool | isLegendEnabled () const
| Returns whether the legend is enabled.
void | setLegendLocation (Side side, AlignmentFlag alignment)
| Configures the location of the legend.
void | setLegendStyle (const WFont &font, const WPen &border, const WBrush &background)
| Configures the legend decoration.
Side | legendSide () const
| Returns the legend side.
AlignmentFlag | legendAlignment () const
| Returns the legend alignment.
int | legendColumns () const
| Returns the number of legend columns.
WLength | legendColumnWidth () const
| Returns the legend column width.
WFont | legendFont () const
| Returns the legend font.
WPen | legendBorder () const
| Returns the legend border pen.
WBrush | legendBackground () const
| Returns the legend background brush.
void | setLegendColumns (int columns, const WLength &columnWidth)
| Configures the number of columns and columnwidth of the legend.
void | initLayout ()
| Initializes the chart layout.
void | setCameraMatrix (const WMatrix4x4 &matrix)
| Set the camera-matrix.
WMatrix4x4 | cameraMatrix () const
| Get the current camera-matrix.
JavaScriptMatrix4x4 | jsMatrix () const
| Get the current camera matrix as a JavaScriptMatrix4x4.
void | updateChart (WFlags< ChartUpdates > flags)
| Update the chart.
void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
Public Member Functions inherited from Wt::WGLWidget
| WGLWidget ()
| Construct a GL widget.
| ~WGLWidget ()
| Destructor.
void | setRenderOptions (WFlags< GLRenderOption > options)
| Sets the rendering option.
void | repaintGL (WFlags< GLClientSideRenderer > which)
| Request invocation of resizeGL, paintGL and/or updateGL.
bool | restoringContext () const
| Returns whether a lost context is in the process of being restored.
void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
void | setClientSideMouseHandler (const std::string &handlerCode)
| Set a custom mouse handler based on the given JavaScript code.
void | setClientSideLookAtHandler (const JavaScriptMatrix4x4 &m, double lX, double lY, double lZ, double uX, double uY, double uZ, double pitchRate, double yawRate)
| Add a mouse handler to the widget that looks at a given point.
void | setClientSideWalkHandler (const JavaScriptMatrix4x4 &m, double frontStep, double rotStep)
| Add a mouse handler to the widget that allows 'walking' in the scene.
void | setAlternativeContent (std::unique_ptr< WWidget > alternative)
| Sets the content to be displayed when WebGL is not available.
JSlot & | repaintSlot ()
| A JavaScript slot that repaints the widget when triggered.
void | enableClientErrorChecks (bool enable=true)
| enable client-side error messages (read detailed doc!)
void | injectJS (const std::string &jsString)
| Inject JavaScript into the current js-stream.
void | activeTexture (GLenum texture)
| GL function to activate an existing texture.
void | attachShader (Program program, Shader shader)
| GL function to attach a shader to a program.
void | bindAttribLocation (Program program, unsigned index, const std::string &name)
| GL function to bind an attribute to a given location.
void | bindBuffer (GLenum target, Buffer buffer)
| GL function to bind a buffer to a target.
void | bindFramebuffer (GLenum target, Framebuffer framebuffer)
| GL function to bind a frame buffer to a target.
void | bindRenderbuffer (GLenum target, Renderbuffer renderbuffer)
| GL function to bind a render buffer to a target.
void | bindTexture (GLenum target, Texture texture)
| GL function to bind a texture to a target.
void | blendColor (double red, double green, double blue, double alpha)
| GL function to set the blending color.
void | blendEquation (GLenum mode)
| GL function to set the blending equation.
void | blendEquationSeparate (GLenum modeRGB, GLenum modeAlpha)
| GL function that sets separate blending functions for RGB and alpha.
void | blendFunc (GLenum sfactor, GLenum dfactor)
| GL function to configure the blending function.
void | blendFuncSeparate (GLenum srcRGB, GLenum dstRGB, GLenum srcAlpha, GLenum dstAlpha)
| GL function that configures the blending function.
void | bufferData (GLenum target, int size, GLenum usage)
| glBufferData - create and initialize a buffer object's data store
void | bufferData (GLenum target, ArrayBuffer res, GLenum usage)
| glBufferData - create and initialize a buffer object's data store from an ArrayBuffer
void | bufferData (GLenum target, ArrayBuffer res, unsigned arrayBufferOffset, unsigned arrayBufferSize, GLenum usage)
| glBufferData - create and initialize a buffer object's data store from an ArrayBuffer
void | bufferSubData (GLenum target, unsigned offset, ArrayBuffer res)
| Initialize a buffer object's data store from an ArrayBuffer.
void | bufferSubData (GLenum target, unsigned offset, ArrayBuffer res, unsigned arrayBufferOffset, unsigned size)
| Initialize a buffer object's data store from an ArrayBuffer.
template<typename Iterator >
void | bufferDatafv (GLenum target, const Iterator begin, const Iterator end, GLenum usage, bool binary=false)
| GL function that loads float or double data in a VBO.
template<typename Iterator >
void | bufferDataiv (GLenum target, const Iterator begin, const Iterator end, GLenum usage, GLenum type)
| GL function that loads integer data in a VBO.
template<typename Iterator >
void | bufferSubDatafv (GLenum target, unsigned offset, const Iterator begin, const Iterator end, bool binary=false)
| GL function that updates an existing VBO with new float or double data.
template<typename Iterator >
void | bufferSubDataiv (GLenum target, unsigned offset, const Iterator begin, Iterator end, GLenum type)
| GL function that updates an existing VBO with new integer data.
void | bufferDatafv (GLenum target, const std::vector< float > &buffer, GLenum usage, bool binary=false)
| GL function that loads float or double data in a VBO.
void | clearBinaryResources ()
| remove all binary buffer resources
void | bufferDataiv (GLenum target, std::vector< int > &buffer, GLenum usage, GLenum type)
| GL function that updates an existing VBO with new integer data.
void | bufferSubDatafv (GLenum target, unsigned offset, const std::vector< float > &buffer, bool binary=false)
| GL function that updates an existing VBO with new float data.
void | bufferSubDataiv (GLenum target, unsigned offset, std::vector< int > &buffer, GLenum type)
| GL function that loads integer data in a VBO.
void | clear (WFlags< GLenum > mask)
| GL function that clears the given buffers.
void | clearColor (double r, double g, double b, double a)
| GL function that sets the clear color of the color buffer.
void | clearDepth (double depth)
| GL function that configures the depth to be set when the depth buffer is cleared.
void | clearStencil (int s)
| GL function.
void | colorMask (bool red, bool green, bool blue, bool alpha)
| GL function.
void | compileShader (Shader shader)
| GL function to compile a shader.
void | copyTexImage2D (GLenum target, int level, GLenum internalformat, int x, int y, unsigned width, unsigned height, int border)
| GL function to copy a texture image.
void | copyTexSubImage2D (GLenum target, int level, int xoffset, int yoffset, int x, int y, unsigned width, unsigned height)
| GL function that copies a part of a texture image.
Buffer | createBuffer ()
| GL function that creates an empty VBO.
Framebuffer | createFramebuffer ()
| GL function that creates a frame buffer object.
Program | createProgram ()
| GL function that creates an empty program.
Renderbuffer | createRenderbuffer ()
| GL function that creates a render buffer object.
Shader | createShader (GLenum shader)
| GL function that creates an empty shader.
Texture | createTexture ()
| GL function that creates an empty texture.
Texture | createTextureAndLoad (const std::string &url)
| GL function that creates an image texture.
std::unique_ptr< WPaintDevice > | createPaintDevice (const WLength &width, const WLength &height)
| returns an paintdevice that can be used to paint a GL texture
void | cullFace (GLenum mode)
| GL function that configures the backface culling mode.
void | deleteBuffer (Buffer buffer)
| GL function that deletes a VBO.
void | deleteFramebuffer (Framebuffer framebuffer)
| GL function that deletes a frame buffer.
void | deleteProgram (Program program)
| GL function that deletes a program.
void | deleteRenderbuffer (Renderbuffer renderbuffer)
| GL function that deletes a render buffer.
void | deleteShader (Shader shader)
| GL function that depetes a shader.
void | deleteTexture (Texture texture)
| GL function that deletes a texture.
void | depthFunc (GLenum func)
| GL function to set the depth test function.
void | depthMask (bool flag)
| GL function that enables or disables writing to the depth buffer.
void | depthRange (double zNear, double zFar)
| GL function that specifies to what range the normalized [-1,1] z values should match.
void | detachShader (Program program, Shader shader)
| GL function that detaches a shader from a program.
void | disable (GLenum cap)
| GL function to disable features.
void | disableVertexAttribArray (AttribLocation index)
| GL function to disable the vertex attribute array.
void | drawArrays (GLenum mode, int first, unsigned count)
| GL function to draw a VBO.
void | drawElements (GLenum mode, unsigned count, GLenum type, unsigned offset)
| GL function to draw indexed VBOs.
void | enable (GLenum cap)
| GL function to enable features.
void | enableVertexAttribArray (AttribLocation index)
| GL function to enable the vertex attribute array.
void | finish ()
| GL function to wait until given commands are executed.
void | flush ()
| GL function to force execution of GL commands in finite time.
void | framebufferRenderbuffer (GLenum target, GLenum attachment, GLenum renderbuffertarget, Renderbuffer renderbuffer)
| GL function to attach the given renderbuffer to the currently bound frame buffer.
void | framebufferTexture2D (GLenum target, GLenum attachment, GLenum textarget, Texture texture, int level)
| GL function to render directly into a texture image.
void | frontFace (GLenum mode)
| GL function that specifies which side of a triangle is the front side.
void | generateMipmap (GLenum target)
| GL function that generates a set of mipmaps for a texture object.
AttribLocation | getAttribLocation (Program program, const std::string &attrib)
| GL function to retrieve an attribute's location in a Program.
UniformLocation | getUniformLocation (Program program, const std::string &location)
| GL function to retrieve a Uniform's location in a Program.
void | hint (GLenum target, GLenum mode)
| GL function to give hints to the render pipeline.
void | lineWidth (double width)
| GL function to set the line width.
void | linkProgram (Program program)
| GL function to link a program.
void | pixelStorei (GLenum pname, int param)
| GL function to set the pixel storage mode.
void | polygonOffset (double factor, double units)
| GL function to apply modifications to Z values.
void | renderbufferStorage (GLenum target, GLenum internalformat, unsigned width, unsigned height)
| GL function to allocate the appropriate amount of memory for a render buffer.
void | sampleCoverage (double value, bool invert)
| GL function to set multisample parameters.
void | scissor (int x, int y, unsigned width, unsigned height)
| GL function to define the scissor box.
void | shaderSource (Shader shader, const std::string &src)
| GL function to set a shader's source code.
void | stencilFunc (GLenum func, int ref, unsigned mask)
| GL function to set stencil test parameters.
void | stencilFuncSeparate (GLenum face, GLenum func, int ref, unsigned mask)
| GL function to set stencil test parameters for front and/or back stencils.
void | stencilMask (unsigned mask)
| GL function to control which bits are to be written in the stencil buffer.
void | stencilMaskSeparate (GLenum face, unsigned mask)
| GL function to control which bits are written to the front and/or back stencil buffers.
void | stencilOp (GLenum fail, GLenum zfail, GLenum zpass)
| GL function to set stencil test actions.
void | stencilOpSeparate (GLenum face, GLenum fail, GLenum zfail, GLenum zpass)
| GL function to set front and/or back stencil test actions separately.
void | texImage2D (GLenum target, int level, GLenum internalformat, unsigned width, unsigned height, int border, GLenum format)
| GL function to reserve space for a 2D texture, without specifying its contents.
void | texImage2D (GLenum target, int level, GLenum internalformat, GLenum format, GLenum type, WImage *image)
| GL function to load a 2D texture from a WImage.
void | texImage2D (GLenum target, int level, GLenum internalformat, GLenum format, GLenum type, WVideo *video)
| GL function to load a 2D texture from a WVideo.
void | texImage2D (GLenum target, int level, GLenum internalformat, GLenum format, GLenum type, std::string filename)
| GL function to load a 2D texture from a file.
void | texImage2D (GLenum target, int level, GLenum internalformat, GLenum format, GLenum type, WPaintDevice *paintdevice)
| GL function to load a 2D texture from a WPaintDevice.
void | texImage2D (GLenum target, int level, GLenum internalformat, GLenum format, GLenum type, Texture texture)
| GL function to load a 2D texture loaded with createTextureAndLoad()
void | texParameteri (GLenum target, GLenum pname, GLenum param)
| GL function to set texture parameters.
void | uniform1f (const UniformLocation &location, double x)
| GL function to set the value of a uniform variable of the current program.
template<typename FloatArray >
void | uniform1fv (const UniformLocation &location, const FloatArray *value)
| GL function to set the value of a uniform variable of the current program.
void | uniform1fv (const UniformLocation &location, const JavaScriptVector &v)
| GL function to set the value of a uniform variable of the current program.
void | uniform1i (const UniformLocation &location, int x)
| GL function to set the value of a uniform variable of the current program.
template<typename IntArray >
void | uniform1iv (const UniformLocation &location, const IntArray *value)
| GL function to set the value of a uniform variable of the current program.
void | uniform2f (const UniformLocation &location, double x, double y)
| GL function to set the value of a uniform variable of the current program.
template<typename FloatArray >
void | uniform2fv (const UniformLocation &location, const FloatArray *value)
| GL function to set the value of a uniform variable of the current program.
void | uniform2fv (const UniformLocation &location, const JavaScriptVector &v)
| GL function to set the value of a uniform variable of the current program.
void | uniform2i (const UniformLocation &location, int x, int y)
| GL function to set the value of a uniform variable of the current program.
template<typename IntArray >
void | uniform2iv (const UniformLocation &location, const IntArray *value)
| GL function to set the value of a uniform variable of the current program.
void | uniform3f (const UniformLocation &location, double x, double y, double z)
| GL function to set the value of a uniform variable of the current program.
template<typename FloatArray >
void | uniform3fv (const UniformLocation &location, const FloatArray *value)
| GL function to set the value of a uniform variable of the current program.
void | uniform3fv (const UniformLocation &location, const JavaScriptVector &v)
| GL function to set the value of a uniform variable of the current program.
void | uniform3i (const UniformLocation &location, int x, int y, int z)
| GL function to set the value of a uniform variable of the current program.
template<typename IntArray >
void | uniform3iv (const UniformLocation &location, const IntArray *value)
| GL function to set the value of a uniform variable of the current program.
void | uniform4f (const UniformLocation &location, double x, double y, double z, double w)
| GL function to set the value of a uniform variable of the current program.
template<typename FloatArray >
void | uniform4fv (const UniformLocation &location, const FloatArray *value)
| GL function to set the value of a uniform variable of the current program.
void | uniform4fv (const UniformLocation &location, const JavaScriptVector &v)
| GL function to set the value of a uniform variable of the current program.
void | uniform4i (const UniformLocation &location, int x, int y, int z, int w)
| GL function to set the value of a uniform variable of the current program.
template<typename IntArray >
void | uniform4iv (const UniformLocation &location, const IntArray *value)
| GL function to set the value of a uniform variable of the current program.
template<typename MatrixType >
void | uniformMatrix2fv (const UniformLocation &location, bool transpose, const MatrixType *value)
| GL function to set the value of a uniform matrix of the current program.
template<typename MatrixType >
void | uniformMatrix2 (const UniformLocation &location, const WGenericMatrix< MatrixType, 2, 2 > &m)
| GL function to set the value of a uniform matrix of the current program.
template<typename MatrixType >
void | uniformMatrix3fv (const UniformLocation &location, bool transpose, const MatrixType *value)
| GL function to set the value of a uniform matrix of the current program.
template<typename MatrixType >
void | uniformMatrix3 (const UniformLocation &location, const WGenericMatrix< MatrixType, 3, 3 > &m)
| GL function to set the value of a uniform matrix of the current program.
template<typename MatrixType >
void | uniformMatrix4fv (const UniformLocation &location, bool transpose, const MatrixType *value)
| GL function to set the value of a uniform matrix of the current program.
template<typename MatrixType >
void | uniformMatrix4 (const UniformLocation &location, const WGenericMatrix< MatrixType, 4, 4 > &m)
| GL function to set the value of a uniform matrix of the current program.
void | uniformMatrix4 (const UniformLocation &location, const JavaScriptMatrix4x4 &m)
| GL function to set the value of a uniform matrix of the current program.
void | useProgram (Program program)
| GL function to set the current active shader program.
void | validateProgram (Program program)
| GL function to validate a program.
void | vertexAttrib1f (AttribLocation location, double x)
| GL function to set the value of an attribute of the current program.
template<typename FloatArray >
void | vertexAttrib1fv (AttribLocation location, const FloatArray *values)
| GL function to set the value of an attribute of the current program.
void | vertexAttrib2f (AttribLocation location, double x, double y)
| GL function to set the value of an attribute of the current program.
template<typename FloatArray >
void | vertexAttrib2fv (AttribLocation location, const FloatArray *values)
| GL function to set the value of an attribute of the current program.
void | vertexAttrib3f (AttribLocation location, double x, double y, double z)
| GL function to set the value of an attribute of the current program.
template<typename FloatArray >
void | vertexAttrib3fv (AttribLocation location, const FloatArray *values)
| GL function to set the value of an attribute of the current program.
void | vertexAttrib4f (AttribLocation location, double x, double y, double z, double w)
| GL function to set the value of an attribute of the current program.
template<typename FloatArray >
void | vertexAttrib4fv (AttribLocation location, const FloatArray *values)
| GL function to set the value of an attribute of the current program.
void | vertexAttribPointer (AttribLocation location, int size, GLenum type, bool normalized, unsigned stride, unsigned offset)
| GL function to bind a VBO to an attribute.
void | viewport (int x, int y, unsigned width, unsigned height)
| GL function to set the viewport.
JavaScriptMatrix4x4 | createJavaScriptMatrix4 ()
| Create a matrix that can be manipulated in client-side JavaScript.
void | addJavaScriptMatrix4 (JavaScriptMatrix4x4 &m)
| Register a matrix with this WGLWidget.
void | initJavaScriptMatrix4 (JavaScriptMatrix4x4 &m)
| Initialize the client-side JavaScript for the given JavaScriptMatrix4x4.
template<typename MatrixType >
void | setJavaScriptMatrix4 (JavaScriptMatrix4x4 &jsm, const WGenericMatrix< MatrixType, 4, 4 > &m)
| Set the value of a client-side JavaScript matrix created by createJavaScriptMatrix4x4()
JavaScriptVector | createJavaScriptVector (unsigned length)
| Create a vector of a certain length that can be manipulated in client-side JavaScript.
void | addJavaScriptVector (JavaScriptVector &v)
| Register a vector with this WGLWidget.
void | initJavaScriptVector (JavaScriptVector &v)
| Initialize the client-side JavaScript for the given JavaScriptVector.
void | setJavaScriptVector (JavaScriptVector &jsv, const std::vector< float > &v)
| Set the value of a client-side JavaScript vector created by createJavaScriptVector()
Public Member Functions inherited from Wt::WInteractWidget
| WInteractWidget ()
| Create an InteractWidget.
EventSignal< WKeyEvent > & | keyWentDown ()
| Event signal emitted when a keyboard key is pushed down.
EventSignal< WKeyEvent > & | keyPressed ()
| Event signal emitted when a "character" was entered.
EventSignal< WKeyEvent > & | keyWentUp ()
| Event signal emitted when a keyboard key is released.
EventSignal & | enterPressed ()
| Event signal emitted when enter was pressed.
EventSignal & | escapePressed ()
| Event signal emitted when escape was pressed.
EventSignal< WMouseEvent > & | clicked ()
| Event signal emitted when the primary mouse button was clicked on this widget.
EventSignal< WMouseEvent > & | doubleClicked ()
| Event signal emitted when the primary mouse button was double clicked on this widget.
EventSignal< WMouseEvent > & | mouseWentDown ()
| Event signal emitted when a mouse button was pushed down on this widget.
EventSignal< WMouseEvent > & | mouseWentUp ()
| Event signal emitted when a mouse button was released on this widget.
EventSignal< WMouseEvent > & | mouseWentOut ()
| Event signal emitted when the mouse went out of this widget.
EventSignal< WMouseEvent > & | mouseWentOver ()
| Event signal emitted when the mouse entered this widget.
EventSignal< WMouseEvent > & | mouseMoved ()
| Event signal emitted when the mouse moved over this widget.
EventSignal< WMouseEvent > & | mouseDragged ()
| Event signal emitted when the mouse is dragged over this widget.
EventSignal< WMouseEvent > & | mouseWheel ()
| Event signal emitted when the mouse scroll wheel was used.
EventSignal< WTouchEvent > & | touchStarted ()
| Event signal emitted when a finger is placed on the screen.
EventSignal< WTouchEvent > & | touchEnded ()
| Event signal emitted when a finger is removed from the screen.
EventSignal< WTouchEvent > & | touchMoved ()
| Event signal emitted when a finger, which is already placed on the screen, is moved across the screen.
EventSignal< WGestureEvent > & | gestureStarted ()
| Event signal emitted when a gesture is started.
EventSignal< WGestureEvent > & | gestureChanged ()
| Event signal emitted when a gesture is changed.
EventSignal< WGestureEvent > & | gestureEnded ()
| Event signal emitted when a gesture is ended.
void | setDraggable (const std::string &mimeType, WWidget *dragWidget=nullptr, bool isDragWidgetOnly=false, WObject *sourceWidget=nullptr)
| Configure dragging for drag and drop.
void | unsetDraggable ()
| Disable drag & drop for this widget.
void | setMouseOverDelay (int delay)
| Sets a delay for the mouse over event.
int | mouseOverDelay () const
| Returns the mouse over signal delay.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
Public Member Functions inherited from Wt::WWebWidget
| WWebWidget ()
| Construct a WebWidget.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
Signal & | childrenChanged ()
| Signal emitted when children have been added or removed.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength()) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | refresh () override
| Refresh the widget.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &id) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &javascript) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
void | setLoadLaterWhenInvisible (bool)
| Change the way the widget is loaded when invisible.
std::string | htmlTagName () const
| returns the current html tag name
void | setHtmlTagName (const std::string &tag)
| set the custom HTML tag name
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
EventSignal & | blurred ()
| Signal emitted when the widget lost focus.
EventSignal & | focussed ()
| Signal emitted when the widget recieved focus.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget)
| Removes a child widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
virtual std::string | objectName () const
| Returns the object name.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
void | initializeGL () override
| Initialize the WebGL state when the widget is first shown.
void | paintGL () override
| Update the client-side painting function.
void | updateGL () override
| Update state set in initializeGL()
void | resizeGL (int width, int height) override
| Act on resize events.
Protected Member Functions inherited from Wt::WGLWidget
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
virtual void | layoutSizeChanged (int width, int height) override
| Virtual method that indicates a size change.
Protected Member Functions inherited from Wt::WInteractWidget
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
Protected Member Functions inherited from Wt::WWebWidget
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
virtual int | boxPadding (Orientation orientation) const
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const
| Returns the widget's built-in border width.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Public Types inherited from Wt::WGLWidget
enum | GLenum
| The enormous GLenum. More...
typedef GLRenderOption | RenderOption
| Typedef for enum Wt::GLRenderOption.
typedef GLClientSideRenderer | ClientSideRenderer
| Typedef for enum Wt::GLClientSideRenderer.
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WWebWidget
static std::string | jsStringLiteral (const std::string &v, char delimiter='\'')
| Turn a CharEncoding::UTF8 encoded string into a JavaScript string literal.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWebWidget
Protected Types inherited from Wt::WWidget
Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A 3D Cartesian chart.

The chart consists of a plotcube, which is always open on the front, and adapts to the data which is shown on the chart. The plotcube has three axes of type WAxis. Each of these can be manually configured as in the 2D case. The chart can be either a ChartType::Scatter or a ChartType::Category. This influences how the data is positioned in relation to the x/y-axis. Gridlines can also be drawn on each of the plotcube-planes. The chart has a mouse-handler which allows rotation of the chart around the center of the plotcube. Zooming in and out is possible by scrolling.

Data that can be shown on the chart derives from WAbstractDataSeries3D. Multiple dataseries can be added to the chart using addDataSeries(). The color of the dataseries is by default determined by the colors of the WChartPalette. This way a separate color is assigned to each new dataseries. All rendering logic of the data is contained in the dataseries-classes and further styling is often possible there. For example, a WAbstractColorMap can be added to a dataseries, which will assign a color to datapoints based on their z-value. More information on this is found in the documentation of WAbstractDataSeries3D.

It is possible to assign a title to the chart. A legend can also be shown that lists the titles of all dataseries (unless disabled in the dataseries itself). The legend position and style can be configured. In addition to title and legend, a colormap-legend is shown for every dataseries which has a colormap enabled and indicates that it should be displayed on the chart.

A scatterplot on the left, a category-chart on the right.

## Constructor & Destructor Documentation

## ◆ WCartesian3DChart() [1/2]

Wt::Chart::WCartesian3DChart::WCartesian3DChart | ( |  | ) |

Constructor.

Constructs a cartesian 3D chart, with the type set to ChartType::Scatter, a transparent background, a PaletteFlavour::Muted palette and no gridlines.

## ◆ WCartesian3DChart() [2/2]

Wt::Chart::WCartesian3DChart::WCartesian3DChart | ( | ChartType | type | ) |

Constructor.

Construct a cartesian 3D chart with the specified type, a transparent background, a PaletteFlavour::Muted palette and no gridlines.

## Member Function Documentation

## ◆ addDataSeries()

void Wt::Chart::WCartesian3DChart::addDataSeries | ( | std::unique_ptr< WAbstractDataSeries3D > | dataseries | ) |

Add a dataseries to the chart.

If the chart is of type ChartType::Scatter only numerical dataseries should be added and if it is of type ChartType::Category only categorical dataseries should be added. If multiple categorical datasets are added, the axis-labels of the first dataseries will be used on the chart.

See also
  removeDataSeries()

## ◆ background()

const WColor & Wt::Chart::WCartesian3DChart::background | ( |  | ) | const

Returns the background color used for this chart.

See also
  setBackground()

## ◆ cameraMatrix()

WMatrix4x4 Wt::Chart::WCartesian3DChart::cameraMatrix | ( |  | ) | const

Get the current camera-matrix.

The matrix represents the current view on the scene. It corresponds to a coordinate system where the chart's axes run from 0 to 1 in all three directions.

See also
  setCameraMatrix()

## ◆ cubeLinesPen()

const WPen & Wt::Chart::WCartesian3DChart::cubeLinesPen | ( |  | ) | const

Returns a reference to the pen used for drawing the edges of the plotcube.

The width and color of the pen are used when drawing the edges of the plotcube

See also
  setCubeLinesPen()

## ◆ dataSeries()

std::vector< WAbstractDataSeries3D * > Wt::Chart::WCartesian3DChart::dataSeries | ( |  | ) | const

Returns all dataseries that were added to this chart.

See also
  addDataSeries(), removeDataSeries()

## ◆ gridLinesPen()

const WPen & Wt::Chart::WCartesian3DChart::gridLinesPen | ( |  | ) | const

Returns the pen used for drawing the gridlines.

See also
  setGridLinesPen()

## ◆ initializeGL()

void Wt::Chart::WCartesian3DChart::initializeGL | ( |  | ) |
| overrideprotectedvirtual

Initialize the WebGL state when the widget is first shown.

Specialized for chart rendering.

Reimplemented from Wt::WGLWidget.

## ◆ initLayout()

void Wt::Chart::WCartesian3DChart::initLayout | ( |  | ) |

Initializes the chart layout.

This method must be called before any methods relating to the layout of the chart are called (eg. calling minimum() or maximum() on one of the axes). The method is also automatically called when the chart is rendered.

## ◆ intersectionLinesColor()

const WColor & Wt::Chart::WCartesian3DChart::intersectionLinesColor | ( |  | ) | const

Gets the color of the intersection lines between surface charts.

See also
  setIntersectionLinesColor()

## ◆ intersectionPlanes()

const std::vector< IntersectionPlane > & Wt::Chart::WCartesian3DChart::intersectionPlanes | ( |  | ) | const

Get the invisible planes with which intersections are drawn.

See also
  setIntersectionPlanes()

## ◆ isGridEnabled()

bool Wt::Chart::WCartesian3DChart::isGridEnabled | ( | Plane | plane,
|  | Axis | axis )

Returns whether the gridlines are enabled.

See also
  setGridEnabled()

## ◆ isIntersectionLinesEnabled()

bool Wt::Chart::WCartesian3DChart::isIntersectionLinesEnabled | ( |  | ) | const

Returns whether intersection lines are shown between surface charts.

See also
  setIntersectionLinesEnabled()

## ◆ isLegendEnabled()

bool Wt::Chart::WCartesian3DChart::isLegendEnabled | ( |  | ) | const

Returns whether the legend is enabled.

See also
  setLegendEnabled()

## ◆ jsMatrix()

JavaScriptMatrix4x4 Wt::Chart::WCartesian3DChart::jsMatrix | ( |  | ) | const

Get the current camera matrix as a JavaScriptMatrix4x4.

This JavaScriptMatrix4x4 can be used to implement a custom mouse handler using setClientSideMouseHandler().

See also
  setCameraMatrix()

## ◆ legendAlignment()

AlignmentFlag Wt::Chart::WCartesian3DChart::legendAlignment | ( |  | ) | const

Returns the legend alignment.

See also
  setLegendLocation()

## ◆ legendBackground()

WBrush Wt::Chart::WCartesian3DChart::legendBackground | ( |  | ) | const

Returns the legend background brush.

See also
  setLegendStyle()

## ◆ legendBorder()

WPen Wt::Chart::WCartesian3DChart::legendBorder | ( |  | ) | const

Returns the legend border pen.

See also
  setLegendStyle()

## ◆ legendColumns()

int Wt::Chart::WCartesian3DChart::legendColumns | ( |  | ) | const

Returns the number of legend columns.

See also
  setLegendColumns()

## ◆ legendColumnWidth()

WLength Wt::Chart::WCartesian3DChart::legendColumnWidth | ( |  | ) | const

Returns the legend column width.

See also
  setLegendColumns()

## ◆ legendFont()

WFont Wt::Chart::WCartesian3DChart::legendFont | ( |  | ) | const

Returns the legend font.

See also
  setLegendStyle()

## ◆ legendSide()

Side Wt::Chart::WCartesian3DChart::legendSide | ( |  | ) | const

Returns the legend side.

See also
  setLegendLocation()

## ◆ paintGL()

void Wt::Chart::WCartesian3DChart::paintGL | ( |  | ) |
| overrideprotectedvirtual

Update the client-side painting function.

Specialized for chart rendering.

Reimplemented from Wt::WGLWidget.

## ◆ palette()

std::shared_ptr< WChartPalette > Wt::Chart::WCartesian3DChart::palette | ( |  | ) | const

Returns the palette used for this chart.

See also
  setPalette()

## ◆ removeDataSeries()

std::unique_ptr< WAbstractDataSeries3D > Wt::Chart::WCartesian3DChart::removeDataSeries | ( | WAbstractDataSeries3D * | dataseries | ) |

Removes a dataseries from a chart.

See also
  addDataSeries()

## ◆ resize()

void Wt::Chart::WCartesian3DChart::resize | ( | const WLength & | width,
|  | const WLength & | height )
| overridevirtual

Resizes the widget.

Specifies a fixed size for this widget, setting CSS `width` and `height` properties. By default a widget has automatic width and height, which sets a size for the widget following CSS rules.

When the widget is not managed by a layout manager, the automatic (natural) size of a widget depends on whether they widget is a block or inline widget:

- a block widget takes by default the width of the parent, and the height that it needs based on its contents
- an inline widget takes the width and height that it needs based on its contents (possibly wrapping over multiple lines). The width and height of an inline widget cannot be changed (by the letter of CSS, although most browsers will react to it in varying ways).

When inserted in a layout manager, the size set will be used as a widget's preferred size, but the widget may be given a different size by the layout manager based on available space and stretch factors. The actual size given by a layout manager may be retrieved by making the widget "layout size aware", using setLayoutSizeAware(). If you have defined a `"wtResize()"` JavaScript method for the widget, then this method will also be called.

The default width and height of a widget is WLength::Auto.

See also
  width(), height()

Reimplemented from Wt::WWebWidget.

## ◆ resizeGL()

void Wt::Chart::WCartesian3DChart::resizeGL | ( | int | width,
|  | int | height )
| overrideprotectedvirtual

Act on resize events.

Specialized for chart rendering.

Reimplemented from Wt::WGLWidget.

## ◆ setAxis()

void Wt::Chart::WCartesian3DChart::setAxis | ( | std::unique_ptr< WAxis > | waxis,
|  | Axis | axis )

Sets an axis.

See also
  axis(Axis axis)

## ◆ setBackground()

void Wt::Chart::WCartesian3DChart::setBackground | ( | const WColor & | background | ) |

Sets the background color for this chart.

This sets the GL-clearcolor. The default is transparant, which will cause the background to have the color set in css.

## ◆ setCameraMatrix()

void Wt::Chart::WCartesian3DChart::setCameraMatrix | ( | const WMatrix4x4 & | matrix | ) |

Set the camera-matrix.

The viewpoint can be set with the camera-matrix. The chart is defined in the world coordinate system as a cube with axes from 0 to 1 in all three directions. Therefore the center of the cube is positioned at (0.5, 0.5, 0.5). The camera can be most easily position with the lookAt method of WMatrix4x4. A common use-case when manipulating the matrix is to translate the center to the origin and then rotate.

For example:

...
WMatrix4x4 camera;
camera.lookAt(0.5, 0.5, z, // camera position
0.5, 0.5, 0.5, // center of the scene
0, 1, 0); // up direction
camera.translate(0.5, 0.5, 0.5);
... // some rotations
camera.translate(-0.5, -0.5, -0.5);

## ◆ setCubeLinesPen()

void Wt::Chart::WCartesian3DChart::setCubeLinesPen | ( | const WPen & | pen | ) |

Sets the pen used to draw the edges of the plotcube.

The default pen for drawing cubelines is a StandardColor::Black pen of width 0.

Note: Only width and color of the pen are used, all other styling is ignored.

## ◆ setGridEnabled()

void Wt::Chart::WCartesian3DChart::setGridEnabled | ( | Plane | plane,
|  | Axis | axis,
|  | bool | enabled = true )

Enable/disable gridlines.

Enables or disables gridlines in the given plane, along the given axis. All gridlines are by default disabled.

## ◆ setGridLinesPen()

void Wt::Chart::WCartesian3DChart::setGridLinesPen | ( | const WPen & | pen | ) |

Sets the pen used for drawing the gridlines.

The default pen for drawing gridlines is a StandardColor::Black pen of width 0.

See also
  gridLinesPen()

## ◆ setIntersectionLinesEnabled()

void Wt::Chart::WCartesian3DChart::setIntersectionLinesEnabled | ( | bool | enabled = true | ) |

Set whether intersection lines are shown between surface charts.

This is disabled by default.

## ◆ setIntersectionPlanes()

void Wt::Chart::WCartesian3DChart::setIntersectionPlanes | ( | const std::vector< IntersectionPlane > & | intersectionPlanes | ) |

Set the invisible planes with which intersections are drawn.

This plane is perpendicular to the given axis, and the intersection is shown in the given color.

Note that render times will take increasingly longer as you add more intersection planes.

## ◆ setLegendColumns()

void Wt::Chart::WCartesian3DChart::setLegendColumns | ( | int | columns,
|  | const WLength & | columnWidth )

Configures the number of columns and columnwidth of the legend.

The default value is a single column, 100 pixels wide.

## ◆ setLegendEnabled()

void Wt::Chart::WCartesian3DChart::setLegendEnabled | ( | bool | enabled | ) |

Enables the legend.

The location of the legend can be configured using setLegendLocation(). Only series for which the legend is enabled are included in this legend.

The default value is `false`.

See also
  setLegendLocation()

## ◆ setLegendLocation()

void Wt::Chart::WCartesian3DChart::setLegendLocation | ( | Side | side,
|  | AlignmentFlag | alignment )

Configures the location of the legend.

The provided `side` can either be Wt::Side::Left, Wt::Side::Right, Wt::Side::Top, Wt::Side::Bottom and configures the side of the chart at which the legend is displayed.

The `alignment` specifies how the legend is aligned. This can be a horizontal alignment flag (Wt::AlignmentFlag::Left, Wt::AlignmentFlag::Center, or Wt::AlignmentFlag::Right), when the `side` is Side::Bottom or Side::Top, or a vertical alignment flag (Wt::AlignmentFlag::Top, Wt::AlignmentFlag::Middle, or Wt::AlignmentFlag::Bottom) when the `side` is Side::Left or Side::Right.

The default location is Wt::Side::Right and Wt::AlignmentFlag::Middle.

See also
  setLegendEnabled()

## ◆ setLegendStyle()

void Wt::Chart::WCartesian3DChart::setLegendStyle | ( | const WFont & | font,
|  | const WPen & | border,
|  | const WBrush & | background )

Configures the legend decoration.

This configures the font, border and background for the legend.

The default font is a 10pt sans serif font (the same as the default axis label font), the default `border` is PenStyle::None and the default `background` is BrushStyle::None.

See also
  setLegendEnabled()

## ◆ setPalette()

void Wt::Chart::WCartesian3DChart::setPalette | ( | const std::shared_ptr< WChartPalette > & | palette | ) |

Sets the palette for this chart.

Ownership of the WChartPalette is transferred to the chart.

The given palette determines which color subsequent dataseries will have. If a dataseries has a colormap set, then the palette is not used for this data.

## ◆ setTitle()

void Wt::Chart::WCartesian3DChart::setTitle | ( | const WString & | title | ) |

Sets the title that is put on the chart.

The title is always put at the top of the chart and in the center.

See also
  setTitleFont()

## ◆ setTitleFont()

void Wt::Chart::WCartesian3DChart::setTitleFont | ( | const WFont & | titleFont | ) |

Sets the font that is used to draw the title.

The default font is the default constructed WFont.

See also
  setTitle()

## ◆ setType()

void Wt::Chart::WCartesian3DChart::setType | ( | ChartType | type | ) |

Sets the type of this chart.

Sets the type of this chart to either ChartType::Scatter (for drawing numerical data) or to ChartType::Category (for drawing categorical data).

## ◆ title()

const WString & Wt::Chart::WCartesian3DChart::title | ( |  | ) | const

Returns the title that is put at the top of this chart.

See also
  setTitle(), setTitleFont()

## ◆ titleFont()

const WFont & Wt::Chart::WCartesian3DChart::titleFont | ( |  | ) | const

Returns the font used to draw the title.

See also
  setTitle(), setTitleFont()

## ◆ type()

ChartType Wt::Chart::WCartesian3DChart::type | ( |  | ) | const

Returns the type of this chart.

See also
  setType()

## ◆ updateGL()

void Wt::Chart::WCartesian3DChart::updateGL | ( |  | ) |
| overrideprotectedvirtual

Update state set in initializeGL()

Specialized for chart rendering.

Reimplemented from Wt::WGLWidget.